/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Ketama.xs. Do not edit this file, edit Ketama.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "xs/Ketama.xs"
/*
    Portions of this code are from libketama, which is licensed
    under GPLv2. Namely, the following functions are based on libketama:
        PerlKetama_md5_digest,
        PerlKetama_create_continuum, 
        PerlKetama_hash_string,
        PerlKetama_hash

    All the rest are by Daisuke Maki.
    Portions of the code made by Daisuke Maki are licensed under
    Artistic License v2 (which includes the pure-Perl contents).

    You should also note that MD5 code is based on another person's code,
    too. However, that file does not carry a GPL license
*/
/*
    For all libketama based code (as noted by above)
    Copyright (C) 2007 by                                          
       Christian Muehlhaeuser <chris@last.fm>
       Richard Jones <rj@last.fm>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 only.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "Ketama.h"
#include "KetamaMD5.h"

#define PERL_KETAMA_TRACE_LEVEL 0
#if (PERL_KETAMA_TRACE_LEVEL > 0)
#define PERL_KETAMA_TRACE(x) warn(x)
#else
#define PERL_KETAMA_TRACE(x)
#endif

static void
PerlKetama_md5_digest( char* in, STRLEN len, unsigned char md5pword[16] )
{
    md5_state_t md5state;

    md5_init( &md5state );
    md5_append( &md5state, (unsigned char *) in, len);
    md5_finish( &md5state, md5pword );
}

// forward declaration
static char *
PerlKetama_hash_internal1( PerlKetama *, char *, STRLEN, unsigned int *);
static char *
PerlKetama_hash_internal2( PerlKetama *, char *, STRLEN, unsigned int *);

static PerlKetama *
PerlKetama_create(SV *class_sv, int hashfunc)
{
    PerlKetama *ketama;

    PERL_UNUSED_VAR(class_sv);

    Newxz( ketama, 1, PerlKetama );
    ketama->numbuckets = 0;
    ketama->numpoints = 0;

    ketama->buckets = NULL;
    ketama->continuum = NULL;

    switch (hashfunc) {
    case 2:
        PERL_KETAMA_TRACE("Using hash_internal2");
        ketama->hashfunc = PerlKetama_hash_internal2;
        break;
    default:
        PERL_KETAMA_TRACE("Using hash_internal1");
        ketama->hashfunc = PerlKetama_hash_internal1;
    }

    return ketama;
}

static MAGIC*
PerlKetama_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    croak("Ketama: Invalid Ketama object was passed");
    return NULL; /* not reached */
}


static void
PerlKetama_clear_continuum(PerlKetama *ketama)
{
    if (ketama->numpoints > 0) {
        Safefree(ketama->continuum);
        ketama->numpoints = 0;
    }
}

static int
PerlKetama_mg_free(pTHX_ SV* const sv, MAGIC* const mg)
{
    PerlKetama* const ketama = (PerlKetama*) mg->mg_ptr;

    PerlKetama_clear_continuum(ketama);

    if (ketama->numbuckets > 0) {
        unsigned int i;
        for(i = 0; i < ketama->numbuckets; i++) {
            Safefree(ketama->buckets[i].label);
        }
        Safefree(ketama->buckets);
    }
    Safefree(ketama);
    PERL_UNUSED_ARG(sv);

    return 0;
}

static void
PerlKetama_add_bucket(PerlKetama *p, char *server, int weight)
{
    int len;
    p->numbuckets++;
    p->totalweight += weight;

    if (p->numbuckets == 1) {
        Newxz( p->buckets, p->numbuckets, PerlKetama_Bucket );
    } else {
        Renew( p->buckets, p->numbuckets, PerlKetama_Bucket );
    }

    len = strlen(server);
    Newxz( p->buckets[p->numbuckets - 1].label, len + 1, char );
    Copy(server, p->buckets[p->numbuckets - 1].label, len + 1, char);

    p->buckets[p->numbuckets - 1].weight = weight;

    PerlKetama_clear_continuum( p );
}

static void
PerlKetama_remove_bucket(PerlKetama *p, char *server)
{
    unsigned int i;

    for( i = 0; i < p->numbuckets; i++ ) {
        if ( strEQ(p->buckets[i].label, server) ) {
            Safefree(p->buckets[i].label);
            p->totalweight -= p->buckets[i].weight;
            for( i += 1; i < p->numbuckets; i++) {
                StructCopy(&(p->buckets[i]), &(p->buckets[i - 1]), PerlKetama_Bucket);
            }
            p->numbuckets--;
            Renew(p->buckets, p->numbuckets, PerlKetama_Bucket);
            i = p->numbuckets;
        }
    }

    PerlKetama_clear_continuum( p );
}

static int
PerlKetama_buckets(PerlKetama *p)
{
    unsigned int i;
    SV *sv;
    dSP;
    PerlKetama_Bucket s;
    SP -= 1; /* must offset for object */

    for(i = 0; i < p->numbuckets; i++) {
        {
            s = p->buckets[i];
            ENTER;
            SAVETMPS;
            PUSHMARK(SP);
            mXPUSHp( "Algorithm::ConsistentHash::Ketama::Bucket", 41 );
            mXPUSHp( "label", 5 );
            mXPUSHp( s.label, strlen(s.label) );
            mXPUSHp( "weight", 6 );
            mXPUSHi( s.weight );
            PUTBACK;

            call_method("new", G_SCALAR);

            SPAGAIN;
    
            sv = POPs;
            SvREFCNT_inc(sv);

            PUTBACK;
            FREETMPS;
            LEAVE;
        }
        XPUSHs( sv );
    }
    return p->numbuckets;
}

static int
PerlKetama_continuum_compare( PerlKetama_Continuum_Point *a, PerlKetama_Continuum_Point *b )
{
    if (a->point < b->point) return -1;
    if (a->point > b->point) return 1;
    return 0;
}

#define MAX_SS_BUF 8192
static void
PerlKetama_create_continuum( PerlKetama *ketama )
{
    unsigned int i, k, h;
    char ss[MAX_SS_BUF];
    unsigned char digest[16];
    unsigned int continuum_idx;
    PerlKetama_Continuum_Point *continuum;

    continuum_idx = 0;
    Newxz(continuum, ketama->numbuckets * 160, PerlKetama_Continuum_Point);

    for ( i = 0; i < ketama->numbuckets; i++ ) {
        PerlKetama_Bucket *b = ketama->buckets + i;
        float pct = b->weight / (float) ketama->totalweight;
        unsigned int k_limit = floorf(pct * 40.0 * ketama->numbuckets);

        for ( k = 0; k < k_limit; k++ ) {
            /* 40 hashes, 4 numbers per hash = 160 points per bucket */
            if (snprintf(ss, MAX_SS_BUF, "%s-%d", b->label, k) >= MAX_SS_BUF) {
                croak("snprintf() overflow detected for key '%s-%d'. Please use shorter labels", b->label, k);
            }
            PerlKetama_md5_digest(ss, strlen(ss), digest);

            for( h = 0; h < 4; h++ ) {
                continuum[ continuum_idx ].point = ( digest[3 + h * 4] << 24 )
                                           | ( digest[2 + h * 4] << 16 )
                                           | ( digest[1 + h * 4] <<  8 )
                                           | ( digest[h * 4] )
                ;
                continuum[ continuum_idx ].bucket = b;
                continuum_idx++;
            }
        }
    }

    Renew( continuum, continuum_idx, PerlKetama_Continuum_Point );
    qsort( (void *) continuum, continuum_idx, sizeof(PerlKetama_Continuum_Point), (compfn) PerlKetama_continuum_compare );

    if (ketama->numpoints > 0) {
        Safefree(ketama->continuum);
    }

    ketama->numpoints = continuum_idx;
    Newxz(ketama->continuum, continuum_idx, PerlKetama_Continuum_Point);
    for (i = 0; i < continuum_idx; i++) {
        ketama->continuum[i].bucket = continuum[i].bucket;
        ketama->continuum[i].point = continuum[i].point; 
    }
    Safefree(continuum);
}

unsigned int
PerlKetama_hash_string( char* in, STRLEN len)
{
    unsigned char digest[16];
    unsigned int ret;

    PerlKetama_md5_digest( in, len, digest );
    ret = ( digest[3] << 24 )
        | ( digest[2] << 16 )
        | ( digest[1] <<  8 )
        |   digest[0];

    return ret;
}

static char *
PerlKetama_hash_internal2( PerlKetama *ketama, char *thing, STRLEN len, unsigned int *thehash )
{
    unsigned int h;
    unsigned int highp;
    unsigned int lowp;
    unsigned int midp;

    if (ketama->numpoints == 0 && ketama->numbuckets > 0) {
        PERL_KETAMA_TRACE("Generating continuum");
        PerlKetama_create_continuum(ketama);
    }

    if (ketama->numpoints == 0) {
        PERL_KETAMA_TRACE("no continuum available");
        return NULL;
    }

    /* Accept either string OR hash number as input */
    if (thing != NULL) {
        h = PerlKetama_hash_string(thing, len);
        *thehash = h;
    }
    else {
        h = *thehash;
    }

    lowp = 0;
    highp = ketama->numpoints;

    while (lowp < highp) {
        midp = lowp + (highp - lowp) / 2;
        if (ketama->continuum[midp].point > h) {
            highp = midp;
        } else {
            lowp = midp + 1;
        }
    }

    if (lowp >= ketama->numpoints) {
       lowp = 0;
    }

    return ketama->continuum[lowp].bucket->label;
}

// This code exist because you might need to keep backwards compatibility
// with older, but possibly broken versions
static char *
PerlKetama_hash_internal1( PerlKetama *ketama, char *thing, STRLEN len, unsigned int *thehash )
{
    unsigned int h;
    unsigned int highp;
    unsigned int maxp  = 0,
        lowp  = 0,
        midp  = 0
    ;
    unsigned int midval, midval1;

    if (ketama->numpoints == 0 && ketama->numbuckets > 0) {
        PERL_KETAMA_TRACE("Generating continuum");
        PerlKetama_create_continuum(ketama);
    }

    if (ketama->numpoints == 0) {
        PERL_KETAMA_TRACE("no continuum available");
        return NULL;
    }

    highp = ketama->numpoints;
    maxp  = highp;

    /* Accept either string OR hash number as input */
    if (thing != NULL) {
        h = PerlKetama_hash_string(thing, len);
        *thehash = h;
    }
    else {
        h = *thehash;
    }

    while ( 1 ) {
        midp = (int)( ( lowp+highp ) / 2 );
        if ( midp >= maxp ) {
            if ( midp == ketama->numpoints ) {
                midp = 1;
            } else {
                midp = maxp;
            }

            return ketama->continuum[midp - 1].bucket->label;
        }
        midval = ketama->continuum[midp].point;
        midval1 = midp == 0 ? 0 : ketama->continuum[midp - 1].point;

        if ( h <= midval && h > midval1 ) {
            return ketama->continuum[midp].bucket->label;
        }

        if ( midval < h )
            lowp = midp + 1;
        else
            highp = midp - 1;

        if ( lowp > highp ) {
            return ketama->continuum[0].bucket->label;
        }
    }
}

char *
PerlKetama_hash( PerlKetama *ketama, SV *thing )
{
    unsigned int hash;
    STRLEN len;
    char *ptr;

    ptr = SvPV(thing, len);

    return ketama->hashfunc(ketama, ptr, len, &hash);
}


#define PerlKetama_xs_create PerlKetama_create

static PerlKetama *
PerlKetama_clone(PerlKetama * const ketama)
{
    PerlKetama_Bucket * const buckets = ketama->buckets;
    PerlKetama_Continuum_Point * const continuum = ketama->continuum;
    unsigned int i, j;
    PerlKetama *newketama = PerlKetama_create(NULL, 1);

    newketama->hashfunc = ketama->hashfunc;
    newketama->totalweight = ketama->totalweight;

    if (ketama->numpoints <= 0) {
        newketama->continuum = NULL;
        newketama->numpoints = 0;
    } else {
        Newxz(newketama->continuum, ketama->numpoints, PerlKetama_Continuum_Point);
        for (i = 0; i < ketama->numpoints; i++) {
            StructCopy(&(continuum[i]), &(newketama->continuum[i]), PerlKetama_Continuum_Point);
        }
        newketama->numpoints = ketama->numpoints;
    }

    if (ketama->numbuckets <= 0) {
        newketama->buckets = NULL;
        newketama->numbuckets = 0;
    } else {
        Newxz(newketama->buckets, ketama->numbuckets, PerlKetama_Bucket);
        for (i = 0; i < ketama->numbuckets; i++ ) {
            StructCopy(&(buckets[i]), &(newketama->buckets[i]), PerlKetama_Bucket);
            Newxz(newketama->buckets[i].label, strlen(buckets[i].label) + 1, char);
            Copy(buckets[i].label, newketama->buckets[i].label, strlen(buckets[i].label) + 1, char);
            if ( ketama->numpoints > 0) {
                int found = 0;
                for (j = 0; j < ketama->numpoints; j++) {
                    if ( strEQ( buckets[i].label, continuum[j].bucket->label ) ) {
                        newketama->continuum[j].bucket = newketama->buckets + i;
                        found = 1;
                        j = ketama->numpoints;
                    }
                }
                if (! found) {
                    croak("SANITY CHECK FAILED: Should not get here");
                }
            }
        }
        newketama->numbuckets = ketama->numbuckets;
    }
    return newketama;
}

static int
PerlKetama_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param){
    PERL_UNUSED_VAR(param);
#ifdef USE_ITHREADS /* single threaded perl has no "xxx_dup()" APIs */
    PerlKetama* const ketama = (PerlKetama*)mg->mg_ptr;
    mg->mg_ptr = (char *) PerlKetama_clone(ketama);
#else
    PERL_UNUSED_VAR(mg);
#endif
    return 0;
}

static MGVTBL PerlKetama_vtbl = { /* for identity */
    NULL, /* get */
    NULL, /* set */
    NULL, /* len */
    NULL, /* clear */
    PerlKetama_mg_free, /* free */
    NULL, /* copy */
    PerlKetama_mg_dup, /* dup */
    NULL,  /* local */
};

#line 502 "xs/Ketama.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 646 "xs/Ketama.c"

XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_xs_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_xs_create)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class_sv, hashfunc");
    {
	SV *	class_sv = ST(0)
;
	int	hashfunc = (int)SvIV(ST(1))
;
	PerlKetama *	RETVAL;

	RETVAL = PerlKetama_xs_create(class_sv, hashfunc);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "Algorithm::ConsistentHash::Ketama";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlKetama_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_add_bucket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_add_bucket)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ketama, label, weight");
    {
	PerlKetama *	ketama;
	char *	label = (char *)SvPV_nolen(ST(1))
;
	int	weight = (int)SvIV(ST(2))
;

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;

	PerlKetama_add_bucket(ketama, label, weight);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_remove_bucket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_remove_bucket)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ketama, label");
    {
	PerlKetama *	ketama;
	char *	label = (char *)SvPV_nolen(ST(1))
;

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;

	PerlKetama_remove_bucket(ketama, label);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_buckets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_buckets)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ketama");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	PerlKetama *	ketama;

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;
#line 516 "xs/Ketama.xs"
        /* since PerlKetama_buckets may push an unknown number of items
           into the Perl stash, this is required */
        XSRETURN( PerlKetama_buckets(ketama) );
#line 777 "xs/Ketama.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_hash)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ketama, thing");
    {
	PerlKetama*	ketama;
	SV *	thing = ST(1)
;
	char *	RETVAL;
	dXSTARG;

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;

	RETVAL = PerlKetama_hash(ketama, thing);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_hash_with_hashnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_hash_with_hashnum)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ketama, thing");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	PerlKetama*	ketama;
	SV *	thing = ST(1)
;
#line 530 "xs/Ketama.xs"
        unsigned int hash;
        char *ptr;
        STRLEN len;
        char *label;
#line 832 "xs/Ketama.c"

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;
#line 535 "xs/Ketama.xs"
        ptr = SvPV(thing, len);
        label = ketama->hashfunc(ketama, ptr, len, &hash);
        mXPUSHp(label, strlen(label));
        mXPUSHu(hash);
        XSRETURN(2);
#line 850 "xs/Ketama.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_label_from_hashnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_label_from_hashnum)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ketama, thing");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	PerlKetama*	ketama;
	unsigned int	thing = (unsigned int)SvUV(ST(1))
;
#line 546 "xs/Ketama.xs"
        char *label;
#line 871 "xs/Ketama.c"

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;
#line 548 "xs/Ketama.xs"
        label = ketama->hashfunc(ketama, NULL, 0, &thing);
        XPUSHs(sv_2mortal(newSVpv(label, strlen(label))));
        XSRETURN(1);
#line 887 "xs/Ketama.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__ConsistentHash__Ketama_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ketama");
    {
	PerlKetama *	ketama;
#line 556 "xs/Ketama.xs"
        SV *class_sv = ST(0);
#line 904 "xs/Ketama.c"
	PerlKetama *	RETVAL;

    {
        MAGIC *mg;
        mg = PerlKetama_mg_find(aTHX_ SvRV(ST(0)), &PerlKetama_vtbl);
        if (mg) {
            ketama = (PerlKetama *) mg->mg_ptr;
        } else {
            croak("not a ketama object");
        }
    }
;

	RETVAL = PerlKetama_clone(ketama);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (!RETVAL)	  /* if null */
		SvOK_off(RETVALSV); /* then return as undef instead of reaf to undef */
	    else {
		/* setup RETVALSV as a ref to a blessed hash hv */
		MAGIC *mg;
		HV *hv = newHV();
		const char *classname = "Algorithm::ConsistentHash::Ketama";
		/* take (sub)class name to use from class_sv if appropriate */
		if (SvMAGICAL(class_sv))
		    mg_get(class_sv);
		if (SvOK( class_sv ) && sv_derived_from(class_sv, classname ) ) {
		    if(SvROK(class_sv) && SvOBJECT(SvRV(class_sv))) {
			classname = sv_reftype(SvRV(class_sv), TRUE);
		    } else {
			classname = SvPV_nolen(class_sv);
		    }
		}
		sv_setsv(RETVALSV, sv_2mortal(newRV_noinc((SV*)hv)));
		(void)sv_bless(RETVALSV, gv_stashpv(classname, TRUE));
		mg = sv_magicext((SV*)hv, NULL, PERL_MAGIC_ext, &PerlKetama_vtbl, (char*) RETVAL, 0);
		mg->mg_flags |= MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Algorithm__ConsistentHash__Ketama); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Algorithm__ConsistentHash__Ketama)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Algorithm::ConsistentHash::Ketama::xs_create", XS_Algorithm__ConsistentHash__Ketama_xs_create);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::add_bucket", XS_Algorithm__ConsistentHash__Ketama_add_bucket);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::remove_bucket", XS_Algorithm__ConsistentHash__Ketama_remove_bucket);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::buckets", XS_Algorithm__ConsistentHash__Ketama_buckets);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::hash", XS_Algorithm__ConsistentHash__Ketama_hash);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::hash_with_hashnum", XS_Algorithm__ConsistentHash__Ketama_hash_with_hashnum);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::label_from_hashnum", XS_Algorithm__ConsistentHash__Ketama_label_from_hashnum);
        newXS_deffile("Algorithm::ConsistentHash::Ketama::clone", XS_Algorithm__ConsistentHash__Ketama_clone);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

